//////////////////////////////////////////////////////////////
//Rechnen ohne Threads aus Kapitel Nebenläufige Programmierung
// Berechne irgend etwas, das viel Zeit braucht
// und nicht vom Java-Übersetzer optimiert werden kann 
/////////////////////////////////////////////////////////////

double computeSomething(long iterations) {

  double res=0;
  for (long i=1; i < iterations; i++ ) 
    res += Math.sin((double)(i));  
  println(res);

  return res;
}

///////////////////////////////////////////////////

void setup() {
 
  double r=0;
  
  int processors = Runtime.getRuntime().availableProcessors();
  println("Der Prozessor hat " + processors + " Kerne");

  // rufe  die rechenintensive Prozedur sooft auf, 
  // wie der Rechner Kerne hat
  
   for (int i=0; i<processors; i++)
     r += computeSomething(10000000+i);  

  println("Rechenzeit: " +millis()/1000.0 + " Sekunden Ergebnis: " + r);
}